services :

  _defaults:
    autowire: true
    public: false

  _instanceof:
    Twig_Extension:
      tags: [ 'twig.extension' ]

    Symfony\Component\EventDispatcher\EventSubscriberInterface:
      tags: [ 'kernel.event_subscriber' ]

  AppBundle\:
    resource: '../../*'
    exclude: '../../{Doctrine}'

  AppBundle\Controller\:
    resource: '../../Controller/*'
    public: true
    tags: ['controller.service_arguments']

  app.cart:
    public : true
    alias: AppBundle\Model\Cart

  AppBundle\Model\Cart:
    factory :
      - AppBundle\Model\Cart
      - create
    arguments :
      - "@session"
      - "@doctrine.orm.default_entity_manager"
      - "@app.manager.configuration"
      - "@app.location_lookup.resolver"

  app.slugger :
    alias : AppBundle\Util\Slugger

  AppBundle\Util\MapperStatic:
    calls :
      - [setUri,           [ "%srwc.google.static_maps_uri.api_endpoint%" ]]
      - [setApi,           [ "%google_api_key_static_maps%" ]]
      - [setOutputPath,    [ "%srwc.system_path.root%", "%srwc.system_path.cached%" ]]

  AppBundle\Util\MapperStreet:
    calls :
      - [setUri,           [ "%srwc.google.street_view_uri.api_endpoint%" ]]
      - [setApi,           [ "%google_api_key_street_view%" ]]
      - [setOutputPath,    [ "%srwc.system_path.root%", "%srwc.system_path.cached%" ]]

  AppBundle\Component\Environment\Environment:
    public : false
    arguments:
      - "%kernel.environment%"
      - "%cache%"

  app.environment:
    public: true
    alias: AppBundle\Component\Environment\Environment

  app.mailer:
    public: true
    alias: AppBundle\Component\Mailer\Mailer

  AppBundle\Util\Directions:
    calls :
      - [setConfigManager, [ "@app.manager.configuration" ]]
      - [setUri, ["%srwc.google.simple_directions_href%"]]

  AppBundle\Twig\UrlExtension:
    arguments :
      - "@router"
      - "@app.environment"
      - "%srwc.url.domain_types%"

  app.twig_extension_helper.cart:
    class  : AppBundle\Twig\Helper\CartTwigExtensionHelper
    public : false
    arguments :
      - "@app.cart"

  AppBundle\Twig\CategoryManagerExtension:
    calls  :
      - [setCategoryManager, ["@app.manager.category"]]

  AppBundle\Twig\CouponManagerExtension:
    calls  :
      - [setCouponManager, ["@app.manager.coupon"]]

  AppBundle\Twig\ContentBlockExtension:
    calls  :
      - [setContentBlockManager, ["@app.manager.content_block"]]

  AppBundle\Twig\ConfigurationExtension:
    calls  :
      - [setConfigurationManager, ["@app.manager.configuration"]]

  AppBundle\Twig\Helper\UrlToFileExtensionHelper:
    public : false
    arguments :
      - "%srwc.system_path.upload%"
      - "%srwc.public_path.upload%"

  AppBundle\Twig\Helper\FrameworkReflectExtensionHelper:
    arguments :
      - '%kernel.environment%'
      - '%kernel.debug%'

  AppBundle\Twig\Locator\TemplateLocator:
    calls :
      - [setKernelRoot, ["%kernel.root_dir%"]]

  app.twig_extension.moment:
    class  : SR\WonkaBundle\Twig\MomentTwigExtension
    public : false
    tags   :
      - { name : twig.extension }

  AppBundle\Twig\FacebookExtension:
    arguments:
      - "@app.fb.provider.page_feed"
      - "@app.environment"

  AppBundle\Twig\Helper\VichFilePathExtensionHelper:
    arguments :
      - product : '%srwc.public_path.image_products%'
        carousel : '%srwc.public_path.image_carousel%'

  app.manager.category :
    alias : AppBundle\Manager\CategoryManager

  app.manager.product :
    alias : AppBundle\Manager\ProductManager

  app.manager.coupon :
    alias : AppBundle\Manager\CouponManager

  app.manager.hours :
    alias : AppBundle\Manager\HoursManager

  app.manager.content_block :
    alias : AppBundle\Manager\ContentBlockManager

  app.manager.carousel_slide :
    alias : AppBundle\Manager\CarouselSlideManager

  app.manager.configuration :
    public: true
    alias : AppBundle\Manager\ConfigurationManager

  Knp\Component\Pager\Paginator:
    alias: knp_paginator

  Doctrine\DBAL\Logging\DebugStack:

  AppBundle\Component\Facebook\Provider\FeedProvider:
    arguments :
      - '@app.fb.auth'
    calls :
      - [setCache, ['@cache.app']]

  app.fb.provider.page_feed :
    alias: AppBundle\Component\Facebook\Provider\FeedProvider

  app.fb.auth :
    class     : AppBundle\Component\Facebook\Authentication\AuthenticationServerSide
    arguments :
      - '%facebook_page_id%'
      - '%facebook_app_id%'
      - '%facebook_app_secret%'
      - '%facebook_graph_version%'
    calls :
      - [setCache, ['@cache.app']]

  app.liip_bundle.remote.loader:
    class     : AppBundle\Component\Imagine\Loader\RemoteLoader
    arguments :
      - "%kernel.cache_dir%/liip/"
      - "@liip_imagine.binary.mime_type_guesser"
      - "@liip_imagine.extension_guesser"
      - "@app.liip_bundle.remote.loader_cache"
    tags:
      - { name: liip_imagine.binary.loader, loader: remote }

  app.liip_bundle.remote.loader_cache:
    class     : AppBundle\Component\Imagine\Loader\Cache\RemoteLoaderCache
    arguments :
      - "%kernel.cache_dir%/liip-loader-cache"
      - "remote"

  #
  # liip remote resolver
  #
  app.liip_bundle.remote.resolver:
    class     : AppBundle\Component\Imagine\Resolver\RemoteResolver
    arguments :
      - "@filesystem"
      - "@router.request_context"
      - "@app.liip_bundle.remote.loader"
      - "%kernel.root_dir%/../web"
      - "%public_cache_dir%"
    tags:
      - { name: liip_imagine.cache.resolver, resolver: remote }

  app.location_lookup.cache:
    class     : AppBundle\Component\Cache\Cache
    arguments :
      - "@cache.app"

  app.location_lookup.maxmind.resolver:
    class     : AppBundle\Component\Location\Resolver\MaxMindResolver
    arguments :
      - "%location_lookup.max_mind.database%"

  app.location_lookup.ip2location.resolver:
    class     : AppBundle\Component\Location\Resolver\Ip2LocationResolver
    arguments :
      - "%location_lookup.ip2location.database%"

  AppBundle\Component\Location\LocationLookup:
    arguments :
      - ["@app.location_lookup.maxmind.resolver", "@app.location_lookup.ip2location.resolver"]
      - "@app.location_lookup.cache"
      - 3600
    calls :
      - [setRequestStack, ["@request_stack"]]

  app.location_lookup.resolver:
    public: true
    alias: AppBundle\Component\Location\LocationLookup
